//GrilleDeBase_201f.js
// 26.03.07 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//Ce script sert  adapter la grille de base

if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// mettre le point zro  zro/zro
app.documents[0].zeroPoint = [0,0];

// relever le pas actuel et le convertir en points
var curDoc = app.documents[0];
var oldStep = (curDoc.gridPreferences.baselineDivision)/0.352777777778;
oldStep = Math.floor((oldStep*1000)+0.5)/1000;

// mmoriser l'option active
var curOpt = curDoc.gridPreferences.baselineGridRelativeOption;

// effacer des dialogues rests ventuellement dans la mmoire
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// crer un dialogue
var oldStart = curDoc.gridPreferences.baselineStart;
var maxVal = 234;
if (maxVal < oldStep) {
	maxVal = oldStep;
}
var aDialog = app.dialogs.add({name:"Grille de base", canCancel:true});
with (aDialog) {
	with (dialogColumns.add()) {
		with (dialogRows.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Pas:", minWidth:100});
						var oldStepVal = realEditboxes.add({editValue:oldStep, minimumValue:1, maximumValue:maxVal, minWidth:40});
						staticTexts.add({staticLabel:"pt", minWidth:4});
						staticTexts.add({staticLabel:" ", minWidth:4});
					}
				}
			}
		}
		with (dialogRows.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Distance au miroir:"});
						var aOffVal = realEditboxes.add({editValue:0, minimumValue:-10, maximumValue:10, minWidth:40});
						staticTexts.add({staticLabel:"mm"});
					}
				}
			}
		}
		with (dialogRows.add()){
			staticTexts.add({staticLabel:" ", minWidth:32});
			with(aligButtons = radiobuttonGroups.add()){
				radiobuttonControls.add({staticLabel:"aligner au miroir (en bas)", checkedState:true});
				radiobuttonControls.add({staticLabel:"ne pas aligner"});
			}
		}
		with (dialogRows.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Dbut:", minWidth:80});
						var oldStartVal = realEditboxes.add({editValue:oldStart, minimumValue:0, maximumValue:123, minWidth:60});
						staticTexts.add({staticLabel:"mm"});
					}
				}
			}
		}
		with (dialogColumns.add()) {
			staticTexts.add({staticLabel:"", minWidth:2});
		}
	}
}

// montrer le dialogue, mmoriser les entres
if (aDialog.show() == true) {
	var newStepVal = oldStepVal.editValue * 0.352777777778;
	var aOff = aOffVal.editValue
	var aligDec = aligButtons.selectedButton;
	var newStart = oldStartVal.editValue;
	// den Dialog lschen
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}

// prparer et appliquer les valeurs
if (aligDec == 0) {
	if (curOpt == 1162766196) {
		var topPos = 0;
	}
	else {
		var topPos = app.activeWindow.activePage.marginPreferences.top;
	}
	var oldStart = curDoc.gridPreferences.baselineStart;
	var botMargin = app.activeWindow.activePage.marginPreferences.bottom;
	var botPos = (curDoc.pages[0].bounds[2] - botMargin) - aOff;
	var aDiff = (botPos - oldStart - topPos) % newStepVal;
	var newStart = (oldStart + aDiff) - newStepVal;
	if (newStart < 0) {
		newStart = newStart + newStepVal;
	}
	curDoc.gridPreferences.baselineStart = newStart;
	curDoc.gridPreferences.baselineDivision = newStepVal;
}
else {
	curDoc.gridPreferences.baselineStart = newStart;
	curDoc.gridPreferences.baselineDivision = newStepVal;
}